package com.malani.examples.jms.transactions;

import javax.naming.InitialContext;
import javax.jms.*;
import java.io.InputStreamReader;

public class TransactedReceiver extends Receiver {
    public static void main(String[] args) {
        System.out.println("Starting...");

        new TransactedReceiver().doAll();

        System.out.println("Ending...");
    }

    protected QueueSession createQueueSession(
        QueueConnection aQC
        ) throws JMSException {
        return aQC.createQueueSession(true, -1);
    }

    protected void processMessage(Message aMessage, QueueSession aQS)
        throws JMSException
    {
        if (aMessage instanceof ObjectMessage) {
            ObjectMessage aOM = (ObjectMessage) aMessage;
            System.out.print(aOM.getObject() + " " );
            Integer i = (Integer) aOM.getObject();
            int ii = i.intValue();
            if (ii == 5) {
                aQS.commit();
            } else if (ii == 9) {
                aQS.rollback();
            }
        }
    }

}
